import numpy as np
import time

# Ponizej funckja transformujaca z 2 wymiaróœ do 35 wymiarów

def transform(x):
    return np.array([x[0]**3, 
    x[1]**3, 
    x[2]**3, 
    x[3]**3,
    np.sqrt(3)*x[0]**2*x[1], 
    np.sqrt(3)*x[0]**2*x[2], 
    np.sqrt(3)*x[0]**2*x[3], 
    np.sqrt(3)*x[0]**2, 
    np.sqrt(3)*x[0]*x[1]**2, 
    np.sqrt(6)*x[0]*x[1]*x[2],
    np.sqrt(6)*x[0]*x[1]*x[3], 
    np.sqrt(6)*x[0]*x[1] ,
    np.sqrt(3)*x[0]*x[2]**2 ,
    np.sqrt(6)*x[0]*x[2]*x[3], 
    np.sqrt(6)*x[0]*x[2] ,
    np.sqrt(3)*x[0]*x[3]**2 ,
    np.sqrt(6)*x[0]*x[3] ,
    np.sqrt(3)*x[0] ,
    np.sqrt(3)*x[1]**2*x[2] ,
    np.sqrt(3)*x[1]**2*x[3] ,
    np.sqrt(3)*x[1]**2 ,
    np.sqrt(3)*x[1]*x[2]**2 ,
    np.sqrt(6)*x[1]*x[2]*x[3], 
    np.sqrt(6)*x[1]*x[2] ,
    np.sqrt(3)*x[1]*x[3]**2 ,
    np.sqrt(6)*x[1]*x[3] ,
    np.sqrt(3)*x[1] ,
    np.sqrt(3)*x[2]**2*x[3] ,
    np.sqrt(3)*x[2]**2,
    np.sqrt(3)*x[2]*x[3]**2 ,
    np.sqrt(6)*x[2]*x[3] ,
    np.sqrt(3)*x[2] ,
    np.sqrt(3)*x[3]**2 ,
    np.sqrt(3)*x[3] ,
    1])


# Generujemy 1000 randomowych elementów 4 wymiarowcyh (zbiór treningowy)
X=np.random.rand(1000,4)

#Przekształcamy funkcją transformujacą i wyliczamy iloczyn skalarny
start = time.time()
Xts = []
y1=0
for x in X:
    xT = transform(x)
    Xts.append(xT)
for x in Xts:
  for xp in Xts:
     y1+=x.dot(xp)
end = time.time()

print('Size for transform : '+str(np.array(Xts).nbytes))

print('For tranform: '+str(end-start))
print(y1)


# Używamy kernela do obliczenia iloczynu skalarnego
start = time.time()
y2=0
for x in X:
  for xp in X:
    y2+=(x.dot(xp)+1)**3

end = time.time()
print('Size for transform : '+str(X.nbytes))
print('For kernel: '+str(end-start))
print(y2)








